;Colour Palette Program by Chris Covell
;-------------------
;Binary created using DAsm 2.12 running on an Amiga.

   PROCESSOR   6502

   ORG   $C000    ;16Kb PRG-ROM, 8Kb CHR-ROM

Reset_Routine  SUBROUTINE
   cld         ;Clear decimal flag
   sei         ;Disable interrupts
.WaitV   lda $2002
   bpl .WaitV     ;Wait for vertical blanking interval
   ldx #$00
   stx $2000
   stx $2001      ;Screen display off, amongst other things
   dex
   txs         ;Top of stack at $1FF

;Clear (most of) the NES' WRAM. This routine is ripped from "Duck Hunt" - I should probably clear all
;$800 bytes.
   ldy #$06    ;To clear 7 x $100 bytes, from $000 to $6FF?
   sty $01        ;Store count value in $01
   ldy #$00
   sty $00
   lda #$00

.Clear   sta ($00),y    ;Clear $100 bytes
   dey
   bne .Clear

   dec $01        ;Decrement "banks" left counter
   bpl .Clear     ;Do next if >= 0


;********* Initialize Palette to specified colour ********

   ldx   #$3F
   stx   $2006
   ldx   #$00
   stx   $2006

   ldx   #$0D     ;Colour Value (Black)
   ldy   #$20     ;Clear BG & Sprite palettes.
.InitPal stx $2007
   dey
   bne   .InitPal
;*********************************************************

;***************** Set Palette ***************************

   ldx   #$3F
   stx   $2006
   ldx   #$00
   stx   $2006
   ldx   #$D
   stx   $2007
   stx   $10      ;Storing Palette in $10 - $2F
   ldx   #$01
   stx   $2007
   stx   $11
   ldx   #$11
   stx   $2007
   stx   $12
   ldx   #$21
   stx   $2007
   stx   $13

   ldx   #$D
   stx   $2007
   stx   $14
   ldx   #$02
   stx   $2007
   stx   $15
   ldx   #$12
   stx   $2007
   stx   $16
   ldx   #$22
   stx   $2007
   stx   $17

   ldx   #$D
   stx   $2007
   stx   $18
   ldx   #$03
   stx   $2007
   stx   $19
   ldx   #$13
   stx   $2007
   stx   $1A
   ldx   #$23
   stx   $2007
   stx   $1B

   ldx   #$D
   stx   $2007
   stx   $1C
   ldx   #$04
   stx   $2007
   stx   $1D
   ldx   #$14
   stx   $2007
   stx   $1E
   ldx   #$24
   stx   $2007
   stx   $1F

   ldx   #$D
   stx   $2007
   stx   $20
   ldx   #$05
   stx   $2007
   stx   $21
   ldx   #$15
   stx   $2007
   stx   $22
   ldx   #$25
   stx   $2007
   stx   $23

   ldx   #$D
   stx   $2007
   stx   $24
   ldx   #$06
   stx   $2007
   stx   $25
   ldx   #$16
   stx   $2007
   stx   $26
   ldx   #$26
   stx   $2007
   stx   $27

   ldx   #$D
   stx   $2007
   stx   $28
   ldx   #$31
   stx   $2007
   stx   $29
   ldx   #$32
   stx   $2007
   stx   $2A
   ldx   #$33
   stx   $2007
   stx   $2B

   ldx   #$D
   stx   $2007
   stx   $2C
   ldx   #$34
   stx   $2007
   stx   $2D
   ldx   #$35
   stx   $2007
   stx   $2E
   ldx   #$36
   stx   $2007
   stx   $2F
;************************************

;************ Set Attribute Table *****************

   ldx   #$23
   stx   $2006
   ldx   #$C8
   stx   $2006

   ldx   #%01000100
   stx   $2007
   ldx   #%11101110
   stx   $2007

   ldx   #$23
   stx   $2006
   ldx   #$D0
   stx   $2006

   ldx   #%01000100
   stx   $2007
   ldx   #%11101110
   stx   $2007

;****************************************************

;******** Set Name Table *******************

   ldx   #$20
   stx   $2006
   ldx   #$80
   stx   $2006

   jsr   Name1

   ldx   #$20
   stx   $2006
   ldx   #$A0
   stx   $2006

   jsr   Name1

   ldx   #$20
   stx   $2006
   ldx   #$C0
   stx   $2006

   jsr   Name2

   ldx   #$20
   stx   $2006
   ldx   #$E0
   stx   $2006

   jsr   Name2

   ldx   #$21
   stx   $2006
   ldx   #$00
   stx   $2006

   jsr   Name3

   ldx   #$21
   stx   $2006
   ldx   #$20
   stx   $2006

   jsr   Name3

   ldx   #$21
   stx   $2006
   ldx   #$40
   stx   $2006

   jsr   Name3

;**************** "PALETTE TEST PROGRAM BY CHRIS C."
   ldx   #$22
   stx   $2006
   ldx   #$00
   stx   $2006

   ldx   #$19
   stx   $2007
   ldx   #$A
   stx   $2007
   ldx   #$15
   stx   $2007
   ldx   #$E
   stx   $2007
   ldx   #$1D
   stx   $2007
   ldx   #$1D
   stx   $2007
   ldx   #$E
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$1D
   stx   $2007
   ldx   #$E
   stx   $2007
   ldx   #$1C
   stx   $2007
   ldx   #$1D
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$19
   stx   $2007
   ldx   #$1B
   stx   $2007
   ldx   #$18
   stx   $2007
   ldx   #$10
   stx   $2007
   ldx   #$1B
   stx   $2007
   ldx   #$A
   stx   $2007
   ldx   #$16
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$B
   stx   $2007
   ldx   #$22
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$C
   stx   $2007
   ldx   #$11
   stx   $2007
   ldx   #$1B
   stx   $2007
   ldx   #$12
   stx   $2007
   ldx   #$1C
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$C
   stx   $2007
   ldx   #$2C
   stx   $2007

;*********************

;********************** " PRESS L,R TO SCROLL PALETTE."

   ldx   #$24
   stx   $2007
   ldx   #$19
   stx   $2007
   ldx   #$1B
   stx   $2007
   ldx   #$E
   stx   $2007
   ldx   #$1C
   stx   $2007
   ldx   #$1C
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$15
   stx   $2007
   ldx   #$28
   stx   $2007
   ldx   #$1B
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$1D
   stx   $2007
   ldx   #$18
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$1C
   stx   $2007
   ldx   #$C
   stx   $2007
   ldx   #$1B
   stx   $2007
   ldx   #$18
   stx   $2007
   ldx   #$15
   stx   $2007
   ldx   #$15
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$19
   stx   $2007
   ldx   #$A
   stx   $2007
   ldx   #$15
   stx   $2007
   ldx   #$E
   stx   $2007
   ldx   #$1D
   stx   $2007
   ldx   #$1D
   stx   $2007
   ldx   #$E
   stx   $2007
   ldx   #$2C
   stx   $2007


;**************************************

;************** Set Sprites (hoo boy!) *****************

   ldx   #$00
   stx   $2003

   ldx   #$1F        ;Sprite 1
   stx   $2004
   ldx   #$01
   stx   $2004
   ldx   #%00000000
   stx   $2004
   ldx   #$40
   stx   $2004

   ldx   #$1F        ;Sprite 2
   stx   $2004
   ldx   #$01
   stx   $2004
   ldx   #%00000000
   stx   $2004
   ldx   #$48
   stx   $2004

   ldx   #$1F        ;Sprite 3
   stx   $2004
   ldx   #$01
   stx   $2004
   ldx   #%00000001
   stx   $2004
   ldx   #$50
   stx   $2004

   ldx   #$1F        ;Sprite 4
   stx   $2004
   ldx   #$01
   stx   $2004
   ldx   #%00000001
   stx   $2004
   ldx   #$58
   stx   $2004

   ldx   #$27        ;Sprite 5
   stx   $2004
   ldx   #$01
   stx   $2004
   ldx   #%00000000
   stx   $2004
   ldx   #$40
   stx   $2004

   ldx   #$27        ;Sprite 6
   stx   $2004
   ldx   #$01
   stx   $2004
   ldx   #%00000000
   stx   $2004
   ldx   #$48
   stx   $2004

   ldx   #$27        ;Sprite 7
   stx   $2004
   ldx   #$01
   stx   $2004
   ldx   #%00000001
   stx   $2004
   ldx   #$50
   stx   $2004

   ldx   #$27        ;Sprite 8
   stx   $2004
   ldx   #$01
   stx   $2004
   ldx   #%00000001
   stx   $2004
   ldx   #$58
   stx   $2004

   ldx   #$2F        ;Sprite 9
   stx   $2004
   ldx   #$02
   stx   $2004
   ldx   #%00000000
   stx   $2004
   ldx   #$40
   stx   $2004

   ldx   #$2F        ;Sprite 10
   stx   $2004
   ldx   #$02
   stx   $2004
   ldx   #%00000000
   stx   $2004
   ldx   #$48
   stx   $2004

   ldx   #$2F        ;Sprite 11
   stx   $2004
   ldx   #$02
   stx   $2004
   ldx   #%00000001
   stx   $2004
   ldx   #$50
   stx   $2004

   ldx   #$2F        ;Sprite 12
   stx   $2004
   ldx   #$02
   stx   $2004
   ldx   #%00000001
   stx   $2004
   ldx   #$58
   stx   $2004

   ldx   #$37        ;Sprite 13
   stx   $2004
   ldx   #$02
   stx   $2004
   ldx   #%00000000
   stx   $2004
   ldx   #$40
   stx   $2004

   ldx   #$37        ;Sprite 14
   stx   $2004
   ldx   #$02
   stx   $2004
   ldx   #%00000000
   stx   $2004
   ldx   #$48
   stx   $2004

   ldx   #$37        ;Sprite 15
   stx   $2004
   ldx   #$02
   stx   $2004
   ldx   #%00000001
   stx   $2004
   ldx   #$50
   stx   $2004

   ldx   #$37        ;Sprite 16
   stx   $2004
   ldx   #$02
   stx   $2004
   ldx   #%00000001
   stx   $2004
   ldx   #$58
   stx   $2004

   ldx   #$3F        ;Sprite 17
   stx   $2004
   ldx   #$03
   stx   $2004
   ldx   #%00000000
   stx   $2004
   ldx   #$40
   stx   $2004

   ldx   #$3F        ;Sprite 18
   stx   $2004
   ldx   #$03
   stx   $2004
   ldx   #%00000000
   stx   $2004
   ldx   #$48
   stx   $2004

   ldx   #$3F        ;Sprite 19
   stx   $2004
   ldx   #$03
   stx   $2004
   ldx   #%00000001
   stx   $2004
   ldx   #$50
   stx   $2004

   ldx   #$3F        ;Sprite 20
   stx   $2004
   ldx   #$03
   stx   $2004
   ldx   #%00000001
   stx   $2004
   ldx   #$58
   stx   $2004

   ldx   #$47        ;Sprite 21
   stx   $2004
   ldx   #$03
   stx   $2004
   ldx   #%00000000
   stx   $2004
   ldx   #$40
   stx   $2004

   ldx   #$47        ;Sprite 22
   stx   $2004
   ldx   #$03
   stx   $2004
   ldx   #%00000000
   stx   $2004
   ldx   #$48
   stx   $2004

   ldx   #$47        ;Sprite 23
   stx   $2004
   ldx   #$03
   stx   $2004
   ldx   #%00000001
   stx   $2004
   ldx   #$50
   stx   $2004

   ldx   #$47        ;Sprite 24
   stx   $2004
   ldx   #$03
   stx   $2004
   ldx   #%00000001
   stx   $2004
   ldx   #$58
   stx   $2004

   ldx   #$4F        ;Sprite 25
   stx   $2004
   ldx   #$01
   stx   $2004
   ldx   #%00000010
   stx   $2004
   ldx   #$00
   stx   $2004

   ldx   #$4F        ;Sprite 26
   stx   $2004
   ldx   #$01
   stx   $2004
   ldx   #%00000010
   stx   $2004
   ldx   #$08
   stx   $2004

   ldx   #$4F        ;Sprite 27
   stx   $2004
   ldx   #$02
   stx   $2004
   ldx   #%00000010
   stx   $2004
   ldx   #$10
   stx   $2004

   ldx   #$4F        ;Sprite 28
   stx   $2004
   ldx   #$02
   stx   $2004
   ldx   #%00000010
   stx   $2004
   ldx   #$18
   stx   $2004

   ldx   #$4F        ;Sprite 29
   stx   $2004
   ldx   #$03
   stx   $2004
   ldx   #%00000010
   stx   $2004
   ldx   #$20
   stx   $2004

   ldx   #$4F        ;Sprite 30
   stx   $2004
   ldx   #$03
   stx   $2004
   ldx   #%00000010
   stx   $2004
   ldx   #$28
   stx   $2004

   ldx   #$4F        ;Sprite 31
   stx   $2004
   ldx   #$01
   stx   $2004
   ldx   #%00000011
   stx   $2004
   ldx   #$30
   stx   $2004

   ldx   #$4F        ;Sprite 32
   stx   $2004
   ldx   #$01
   stx   $2004
   ldx   #%00000011
   stx   $2004
   ldx   #$38
   stx   $2004

   ldx   #$4F        ;Sprite 33
   stx   $2004
   ldx   #$02
   stx   $2004
   ldx   #%00000011
   stx   $2004
   ldx   #$40
   stx   $2004

   ldx   #$4F        ;Sprite 34
   stx   $2004
   ldx   #$02
   stx   $2004
   ldx   #%00000011
   stx   $2004
   ldx   #$48
   stx   $2004

   ldx   #$4F        ;Sprite 35
   stx   $2004
   ldx   #$03
   stx   $2004
   ldx   #%00000011
   stx   $2004
   ldx   #$50
   stx   $2004

   ldx   #$4F        ;Sprite 36
   stx   $2004
   ldx   #$03
   stx   $2004
   ldx   #%00000011
   stx   $2004
   ldx   #$58
   stx   $2004


   ldx   #$57        ;Sprite 37
   stx   $2004
   ldx   #$01
   stx   $2004
   ldx   #%00000010
   stx   $2004
   ldx   #$00
   stx   $2004

   ldx   #$57        ;Sprite 38
   stx   $2004
   ldx   #$01
   stx   $2004
   ldx   #%00000010
   stx   $2004
   ldx   #$08
   stx   $2004

   ldx   #$57        ;Sprite 39
   stx   $2004
   ldx   #$02
   stx   $2004
   ldx   #%00000010
   stx   $2004
   ldx   #$10
   stx   $2004

   ldx   #$57        ;Sprite 40
   stx   $2004
   ldx   #$02
   stx   $2004
   ldx   #%00000010
   stx   $2004
   ldx   #$18
   stx   $2004

   ldx   #$57        ;Sprite 41
   stx   $2004
   ldx   #$03
   stx   $2004
   ldx   #%00000010
   stx   $2004
   ldx   #$20
   stx   $2004

   ldx   #$57        ;Sprite 42
   stx   $2004
   ldx   #$03
   stx   $2004
   ldx   #%00000010
   stx   $2004
   ldx   #$28
   stx   $2004

   ldx   #$57        ;Sprite 43
   stx   $2004
   ldx   #$01
   stx   $2004
   ldx   #%00000011
   stx   $2004
   ldx   #$30
   stx   $2004

   ldx   #$57        ;Sprite 44
   stx   $2004
   ldx   #$01
   stx   $2004
   ldx   #%00000011
   stx   $2004
   ldx   #$38
   stx   $2004

   ldx   #$57        ;Sprite 45
   stx   $2004
   ldx   #$02
   stx   $2004
   ldx   #%00000011
   stx   $2004
   ldx   #$40
   stx   $2004

   ldx   #$57        ;Sprite 46
   stx   $2004
   ldx   #$02
   stx   $2004
   ldx   #%00000011
   stx   $2004
   ldx   #$48
   stx   $2004

   ldx   #$57        ;Sprite 47
   stx   $2004
   ldx   #$03
   stx   $2004
   ldx   #%00000011
   stx   $2004
   ldx   #$50
   stx   $2004

   ldx   #$57        ;Sprite 48
   stx   $2004
   ldx   #$03
   stx   $2004
   ldx   #%00000011
   stx   $2004
   ldx   #$58
   stx   $2004
;**************** End of Sprites *****************


;Enable vblank interrupts, etc.
   lda   #$80
   sta   $2000
   lda   #$1E       ;Screen on, sprites on, show leftmost 8 pixels, colour
   sta   $2001
   cli            ;Enable interrupts(?)

;Now just loop forever?
.Loop jmp   .Loop

Name1 SUBROUTINE
   ldx   #$01
   ldy   #$08
.FillName   stx   $2007
   dey
   bne   .FillName
   rts

Name2 SUBROUTINE
   ldx   #$02
   ldy   #$08
.FillName2  stx   $2007
   dey
   bne   .FillName2
   rts

Name3 SUBROUTINE
   ldx   #$03
   ldy   #$08
.FillName3  stx   $2007
   dey
   bne   .FillName3
   rts

BlackBG SUBROUTINE
   pha            ;Push A on stack
   txa
   pha            ;Push X on stack

   ldx   #$3F
   stx   $2006
   ldx   #$00
   stx   $2006
   ldx   #$D
   stx   $2007

   ldx   #$3F
   stx   $2006
   sty   $2006

   pla            ;Pull X from stack
   tax
   pla            ;Pull A from stack
   rts

NMI_Routine SUBROUTINE

;First, save the registers
   php
   pha
   txa
   pha
   tya
   pha

   ldx   $00      ;Get previous button status byte
   stx   $01      ;Put it in $01

;Controller read routine, by Kevin Horton.

   LDY   #$08     ;Number of iterations
   LDX   #$01
   STX   $4016    ;store 1 out the strobe
   DEX
   STX   $4016    ;store 0 out the strobe
.ReadBit
   LDA   $4016    ;read the button
   ROR         ;transfer it to the carry flag
   TXA
   ROL
   TAX         ;rotate X left, storing the bit into the lowest pos.
   DEY
   BNE   .ReadBit ;loop 8 times for all 8 buttons
;  RTS         ;return acc with status of all 8 buttons

   and   #$03     ;Only interested in L & R at the moment
   sta   $00      ;Use location 0 for storing current controller button data

;Next inst unnecessary since last inst was sta $00
;  lda   $00      ;Get current button status
   beq   .DoNothing  ;If neither button pressed

   lda   $01      ;Get previous button status
   eor   #$FF     ;NOT it
   and   $00      ;AND this with current status
   beq   .DoNothing  ;If no change from last time, do nothing

   ror         ;So R status in carry
   bcc   .NotR

;Shift palette up

   ldx   #$1
   ldy   #$1F
.Up1   inc   $10,X
   inx
   dey
   bne   .Up1



.NotR ror         ;So L status in carry
   bcc   .NotL

;Shift palette down

   ldx   #$1
   ldy   #$1F
.Dn1   dec   $10,X
   inx
   dey
   bne   .Dn1

.NotL

   ldx   #$3F
   stx   $2006
   ldx   #$01
   stx   $2006

   ldy   #$1
   lda   #$1F
.SavePal ldx   $10,Y
   stx   $2007
   iny
   jsr   BlackBG
   sec
   sbc   #$01
   bne   .SavePal


.DoNothing        ;Restore registers and exit.

   ldx   #$0
   stx   $2005
   stx   $2005

   pla
   tay
   pla
   tax
   pla
   plp

IRQ_Routine       ;Dummy label
   rti

;That's all the code. Now we just need to set the vector table approriately.

   ORG   $FFFA,0
   dc.w  NMI_Routine
   dc.w  Reset_Routine
   dc.w  IRQ_Routine    ;Not used, just points to RTI


;The end.
